Exception.InnerException Exception.InnerException Exception.InnerException Exception.InnerException Property

Definición

Obtiene la instancia Exception que produjo la excepción actual.Gets the Exception instance that caused the current exception.

public:
 property Exception ^ InnerException { Exception ^ get(); };
public Exception InnerException { get; }
member this.InnerException : Exception
Public ReadOnly Property InnerException As Exception

Valor de propiedad

Objeto que describe el error que causó la excepción actual.An object that describes the error that caused the current exception. La propiedad InnerException devuelve el mismo valor que se pasó al constructor Exception(String, Exception) o null si no se suministró el valor de la excepción interna al constructor.The InnerException property returns the same value as was passed into the Exception(String, Exception) constructor, or null if the inner exception value was not supplied to the constructor. Esta propiedad es de sólo lectura.This property is read-only.

Implementaciones

Ejemplos

En el ejemplo siguiente se muestra cómo iniciar y detectar una excepción que hace referencia a una excepción interna.The following example demonstrates throwing and catching an exception that references an inner exception.

using namespace System;

public ref class AppException: public Exception
{
public:
   AppException(String^ message ) : Exception(message)
   {}

   AppException(String^ message, Exception^ inner) : Exception(message, inner)
   {}
};

public ref class Example
{
public:
   void ThrowInner()
   {
      throw gcnew AppException("Exception in ThrowInner method.");
   }

   void CatchInner()
   {
      try {
         this->ThrowInner();
      }
      catch (AppException^ e) {
         throw gcnew AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
};

int main()
{
   Example^ ex = gcnew Example();
   try {
      ex->CatchInner();
   }
   catch (AppException^ e) {
      Console::WriteLine("In catch block of Main method.");
      Console::WriteLine("Caught: {0}", e->Message);
      if (e->InnerException != nullptr)
         Console::WriteLine("Inner exception: {0}", e->InnerException);
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
using System;

public class AppException : Exception
{
   public AppException(String message) : base (message)
   {}

   public AppException(String message, Exception inner) : base(message,inner) {}
}

public class Example
{
   public static void Main()
   {
      Example ex = new Example();

      try {
         ex.CatchInner();
      }
      catch(AppException e) {
         Console.WriteLine ("In catch block of Main method.");
         Console.WriteLine("Caught: {0}", e.Message);
         if (e.InnerException != null)
            Console.WriteLine("Inner exception: {0}", e.InnerException);
      }
   }

   public void ThrowInner ()
   {
      throw new AppException("Exception in ThrowInner method.");
   }

   public void CatchInner() 
   {
      try {
         this.ThrowInner();
      }
      catch (AppException e) {
         throw new AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
      }
   }
}
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()
Public Class AppException : Inherits Exception
   Public Sub New(message As String)
      MyBase.New(message)
   End Sub
   
   Public Sub New(message As String, inner As Exception)
      MyBase.New(message, inner)
   End Sub
End Class

Public Class Example
   Public Shared Sub Main()
      Dim testInstance As New Example()
      Try
         testInstance.CatchInner()
      Catch e As AppException
         Console.WriteLine ("In catch block of Main method.")
         Console.WriteLine("Caught: {0}", e.Message)
         If e.InnerException IsNot Nothing Then
            Console.WriteLine("Inner exception: {0}", e.InnerException)
         End If
      End Try
   End Sub
   
   Public Sub ThrowInner()
      Throw New AppException("Exception in ThrowInner method.")
   End Sub
   
   Public Sub CatchInner()
      Try
         Me.ThrowInner()
      Catch e As AppException
         Throw New AppException("Error in CatchInner caused by calling the ThrowInner method.", e)
      End Try
   End Sub
End Class
' The example displays the following output:
'    In catch block of Main method.
'    Caught: Error in CatchInner caused by calling the ThrowInner method.
'    Inner exception: AppException: Exception in ThrowInner method.
'       at Example.CatchInner()

Comentarios

Cuando se produce X una excepción como resultado directo de una excepción Yanterior, la InnerException propiedad de X debe contener una referencia a Y.When an exception X is thrown as a direct result of a previous exception Y, the InnerException property of X should contain a reference to Y.

Utilice la propiedad InnerException para obtener el conjunto de excepciones que dieron lugar a la excepción actual.Use the InnerException property to obtain the set of exceptions that led to the current exception.

Puede crear una nueva excepción que detecte una excepción anterior.You can create a new exception that catches an earlier exception. El código que controla la segunda excepción puede usar la información adicional de la excepción anterior para controlar el error más adecuadamente.The code that handles the second exception can make use of the additional information from the earlier exception to handle the error more appropriately.

Suponga que hay una función que lee un archivo y da formato a los datos de ese archivo.Suppose that there is a function that reads a file and formats the data from that file. En este ejemplo, cuando el código intenta leer el archivo, se produce IOException una excepción.In this example, as the code tries to read the file, an IOException is thrown. La función detecta IOException y produce una FileNotFoundExceptionexcepción.The function catches the IOException and throws a FileNotFoundException. Se puede guardar en la InnerException propiedad de FileNotFoundException, habilitando el código que detecta el FileNotFoundException para examinar la causa del error inicial. IOExceptionThe IOException could be saved in the InnerException property of the FileNotFoundException, enabling the code that catches the FileNotFoundException to examine the cause of the initial error.

La InnerException propiedad, que contiene una referencia a la excepción interna, se establece al inicializarse el objeto de excepción.The InnerException property, which holds a reference to the inner exception, is set upon initialization of the exception object.

Se aplica a